<?

/*

   Copyright (c), 1999, 2000 - phpauction.org                  
   

   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation (version 2 or later).                                  

   This program is distributed in the hope that it will be useful,      
   but WITHOUT ANY WARRANTY; without even the implied warranty of       
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
   GNU General Public License for more details.                         

   You should have received a copy of the GNU General Public License    
   along with this program; if not, write to the Free Software          
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   

*/


	/*======================================================================
	
		Edit the lines below *
	
		Both *nix and Windows directives are present. Default is *nix.
		If you are running Phpauction under Windows comment the first line
		of each couple, uncomment the second and edit it to reflect you box
		charactaristics.
		Note: windows slash (\) must be preceeded by another \ for PHP to read
		the path correctly.
	
	======================================================================*/
	

	$SITE_NAME = "YOUR SITE NAME";
	$SITE_URL  = "http://172.26.0.4/phpauction/"; //Requires ending slash
	
	$COOKIE_PREFIX = "PHPAUCTION";
	$LOGGED_IN_COOKIE = $COOKIE_PREFIX."_LOGGED_IN";
	$LOGGED_IN_NICK = $COOKIE_PREFIX."NICK_LOGGED_IN";
	
	//-- Activate login box
	//-- 1 means login box is shown in the right column in the home page
	//-- 0 means login box is not shown
	$LOGIN_BOX = 1;

	
	//-- Activate News box
	//-- 1 means News box is shown in the right column in the home page
	//-- 0 means News box is not shown
	$NEWS_BOX = 1;
	$NEWS_TO_SHOW = 5; // Number of news you want to show in the NEWS column
	
	
	/*========================================================================================
		MONEY FORNATTING OPTIONS
	
		You can choose between:
			
			$MONEY_FORMAT = 1 => US notation: 							1,500.00
			$MONEY_FORMAT = 2 => NON US notation	(Europe style) 1.500,00	
		
		and also define the number of decimal digits you want to be shown
		
			$MONEY_DECIMALS = 2; (2 is the default)
		
		and the position of the currency symbol:
			
			$MONEY_SYMBOL_POS = "R" => the currency symbol will be displayed AFTER the amount
			$MONEY_SYMBOL_POS = "L" => the currency symbol will be displayed BEFORE the amount
	=========================================================================================*/
	
		$MONEY_FORMAT 		= 1;
		$MONEY_DECIMALS 	= 2;
		$MONEY_SYMBOL_POS = "L";
		
		

   //-- This is the directory where passwd.inc.php file resides - requires ending slash
  	
  	$include_path = "./includes/"; 
  	#$include_path = "C:\\some\\path\\to\\includes\\"; 


  	//-- This is the directory where users pictures will be uploaded - requires ending slash
  	//-- Under Windows use something like C:\\path\\to\\you\\uploaddir\\

  	$image_upload_path = "/var/www/phpauction/uploaded/"; 
  	#$image_upload_path = "C:\\some\\path\\to\\uploaded\\"; 
  	$uploaded_path = "uploaded/"; 
  	#$uploaded_path = "uploaded\\"; 
  

	//--
  	$MAX_UPLOAD_SIZE = 100000;

	
	
	//-- This string is added to passwords before generating the MD5 hash
	//-- Be sure to never change it after the firt set up or 
	//-- your users passwords will not work
	
	$MD5_PREFIX = "put_here_along_and_unpredictable_string";
	
	
	
	//-- Wether or not you want to show the acceptance text contained in
	//-- acceptance.inc.php in users registration page

	$SHOW_ACCEPTANCE_TEXT = 1;
	
	
  	/*
  		This is the log file generated by cron.php - insert the complete
  		file name (including the absolute path).
  		If you don't want to generate a log file for cron activity simply
  		leave this line commented.
  	*/

  	#$logFileName = "/var/www/auctions/logs/cron.log"; 
  	#$logFileName = "C:\\path\\to\cron.log"; 

	/*
		Set this to TRUE if you want cron to generates HTML output
		BESIDES the cron file declared above. cron.php cannot generates
		only HTML output.
	*/
  	$cronScriptHTMLOutput = FALSE;


  	$expireAuction = 60*60*24*30; // time of auction expiration (in seconds)
  	$sessionLifeTime = 60*60*24*2; // time of a user session lifetime



  //-- some constants

  $err_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"2\" COLOR=red>";
  $std_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"2\">";
  $sml_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"1\">";
  $smlnav_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"1\" COLOR=white>";
  $tlt_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"4\">";
  $tlt2_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"3\">";
  $usr_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"4\" COLOR=\"#F6AF17\">";
  $nav_font = "<FONT FACE=\"Verdana,Arial,Helvetica\" SIZE=\"2\" COLOR=\"#FFFFFF\">";





  /*======================================================================
   *																							  *																	
   * Don't edit the code below unless you really know what you are doing  *
   *																							  *          															
   ======================================================================*/	

	//--
  if(strpos($PHP_SELF,"admin/")){
  	$password_file = "../".$include_path."passwd.inc.php";
  }else{
  	$password_file = $include_path."passwd.inc.php";
  }
  	
  	
  	
  //-- Site administrator's email

  if(strpos($PHP_SELF,"admin/")){
  	include("../includes/adminmail.inc.php");
  }else{
  	include("./includes/adminmail.inc.php");
  }

  if(strpos($PHP_SELF,"admin/")){
  	include("../includes/currency.inc.php");
  }else{
  	include("./includes/currency.inc.php");
  }


  include($password_file);

  //-- Database connection

  mysql_pconnect($DbHost,$DbUser,$DbPassword)
  	or die("Database access error. Please contact the site administrator.");
  mysql_select_db($DbDatabase);


  //-- sessions support

  if(strpos($PHP_SELF,"admin/")){
  	include("../includes/sessions.inc.php");
  }else{
  	include("./includes/sessions.inc.php");
  }



?>
