#
# --Confirmation e-mail file
# 
# 			This file contains the message your customers
# 			will receive as a confirmation for the posted
#			auction.
#			Lines starting with # will be skipped.
#			Blank lines will be maintained.
#
#			Change the message below as needed considering the 
#			following tags to reflect your customer's personal data:
#
#        --------------------------------------------------------
#			TAG SYNTAX				EFFECT
#        --------------------------------------------------------
#
#			<#c_name#>				customer name
#			<#c_nick#>				nick
#			<#c_email#> 			e-mail address
#			<#c_address#> 			street address
#			<#c_city#>   			city
#			<#c_country#> 			country
#			<#c_zip#> 			    zip
#			<#a_title#>				auction title
#			<#a_id#>					auction ID
#			<#a_description#>		description
#			<#a_picturl#>			picture url
#			<#a_minbid#>   		minimum bid
#			<#a_resprice#>			reserve price (if set)
#			<#a_duration#>			duration (in days)
#			<#a_location#>			item location
#			<#a_zip#>				item location zip
#			<#a_shipping#>			shipping terms
#			<#a_intern#>			international shipping terms
#											. will ship internationally
#											. will NOT ship internationally
#			<#a_payment#>			selected payment methods (one per line)
#			<#a_category#>			item's category choosen
#			<#a_subcategory#>		item's subcategory choosen
#			<#a_ends#>				closing date and time
#			<#a_url#>				the URL of the page
#           <#c_sitename#>          site name
#           <#c_siteurl#>           site URL
#           <#c_adminemail#>        site administrator email address
#        --------------------------------------------------------
#
#			USAGE:
#			Insert the above tags in the text of your message			
#			where you want each value to appear.			
#			Modify the message to reflect your needs.
#			Change [...] with to your correct data.
#
# 
#

Dear <#c_name#>,

Your auction has been posted at <#c_sitename#>.  

# you text here
Auction ID: <#a_id#>  
Product: <#a_title#>
Category: <#a_category#> 
Description: <#a_description#>

Starting bid: <#a_minbid#>
Reserve price: <#a_resprice#>
Auction URL: <#a_url#>
Auction ends: <#a_ends#>

# More text here

If you have received this message in error, please reply to this email or
write to <#c_adminemail#>.

Thank you for visiting <#c_sitename#> at <#c_siteurl#>.