<?
  
  
/*

   Copyright (c), 1999, 2000 - phpauction.org                  
   
   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation (version 2 or later).                                  
                                                                        
   This program is distributed in the hope that it will be useful,      
   but WITHOUT ANY WARRANTY; without even the implied warranty of       
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
   GNU General Public License for more details.                         
                                                                        
   You should have received a copy of the GNU General Public License    
   along with this program; if not, write to the Free Software          
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*/

$currency ="USD";


// You can modify currency symbol position by modifying the function 
// You may also modify the decimal markers by changeing number_format
// See the php manual for more information on number_format()

if($MONEY_FORMAT == 1)
{
	function print_money($str){
		global $currency, $MONEY_SYMBOL_POS, $MONEY_DECIMALS;
		if($MONEY_SYMBOL_POS == "R")
		{
			return number_format($str,$MONEY_DECIMALS,".",",") . "&nbsp;" . $currency;
		}
		elseif($MONEY_SYMBOL_POS == "L")
		{
			return $currency . "&nbsp;" . number_format($str,$MONEY_DECIMALS,".",",");
		}
	}
}
elseif($MONEY_FORMAT == 2)
{
	function print_money($str){
		global $currency, $MONEY_SYMBOL_POS, $MONEY_DECIMALS;
		if($MONEY_SYMBOL_POS == "R")
		{
			return number_format($str,$MONEY_DECIMALS,",",".") . "&nbsp;" . $currency;;
		}
		elseif($MONEY_SYMBOL_POS == "L")
		{
			return $currency . "&nbsp;" . number_format($str,$MONEY_DECIMALS,",",".");
		}
	}
}


// when dealing with money, we really dont ever want fancy formating, so 
// we remove it from any input value. You need to make sure this works 
// with however you have formatted print money above.

function input_money($str){
	global $currency;
	$str = ereg_replace("[^0-9\.]","",$str);
	return $str;
}

?>
